#ifndef DOMAIN_H
#define DOMAIN_H


typedef struct{
    	/* nbVal_prof[prof][u] = number of values in D[u] at depth prof in the search tree */
	unsigned short **nbVal_prof;
	
	/* firstVal[u] = pos in val of the first value of D[u] */
	unsigned short *firstVal;
	
	/* val[firstVal[u]..firstVal[u]+nbVal[u]-1] = values of D[u] */
	unsigned short *val;
    
    	/* If v in D[u] then firstVal[u] <= posInVal[u][v] < firstVal[u]+nbVal[u] and val[posInVal[u][v]] = v */
	unsigned short **posInVal;
    	/* otherwise posInVal[u][v] >= firstVal[u]+nbVal[u] */

	/* size of val */
	unsigned short valSize;
	
	/* compat[v1][v2]=1 if v1 and v2 are compatible values in val */
    	char **compat;
    
	/* posInComp[u][v] is the position in compat of the value v in the domain of u */
    	unsigned short **posInComp;
	
	int* globalMatching; // globalMatching[u] = node of Gt matched to u in globalSoftAllDiff
	int* solution; // the best solution
	int* current_sol; // the current solution
	int** nbDomincludingVal_prof;// nbDomincludingVal_prof[prof][v] = number of domains containing the value v at the depth prof
} Tdomain;

#endif
