#ifndef HEURISTICS_H
#define HEURISTICS_H

#include "graph.h"
#include "domain.h"

int choose_node_mindom(Tdomain* D, Tgraph* Gp, int prof);
// return the vertex of Gp with the fewest values in its not empty domain at depth prof in the search tree or -1 if all domains are empty 


int choose_node_mindom_cc(Tdomain* D, Tgraph* Gp, int prof, char* connected);
// return the vertex of Gp included in the set connected with the fewest values in its not empty domain at depth prof in the search tree or -1 if all domains of vertices in connected are empty


int choose_value_gmatch_mindiff(Tdomain* D, int* Gp_deg, int* Gt_deg, int minDom, int prof);
// return the vertex in Gt matched to the vertex minDom in Gp if any, or the vertex of Gt in the domain of minDom at the depth prof in the search tree with the closest degree if any, or -2 otherwise


#endif
