#ifndef HOPCROFT_KARP_H
#define HOPCROFT_KARP_H

#include "domain.h"
#include "colors.h"




int updateMatching(
				   int sizeOfU, // number of elements in U
				   int sizeOfV, // number of elements in V
				   Tdomain* D, // for each element u of U, D represents the elements of V compatible with u at a given depth in the search tree
				   int prof,  // depth in the search tree 
				   int*  matchedWithU // matchedWithU[i] = element of V matched with the ith element of U
);
   // compute a largest matching matchedWithU and return the size of the matching




int updateMatching_lazy(
				   int sizeOfU, // number of elements in U
				   int sizeOfV, // number of elements in V
				   Tdomain* D, // for each element u of U, D represents the elements of V compatible with u at a given depth in the search tree
				   int prof, // depth in the search tree 
				   int*  matchedWithU, // matchedWithU[i] = element of V matched with the ith element of U
				   int maxSize
);
   // try to compute a matching, matchedWithU, whose size is greater than maxSize+1 (and stops as soon as it is achieved) if there exists any  
   // return the size of the matching

#endif
