#ifndef TOOLS_H
#define TOOLS_H

#include "graph.h"
#include "domain.h"

int isInD_prof(int u, int v, Tdomain* D, int prof);
	// return true if v belongs to the domain of u at the depth prof in the search tree; false otherwise

	
int last_pos(int u, int v, int prof, Tdomain* D, Tgraph* Gp);
	// remove v from the domain of u at the depth prof in the search tree and update the globalMatching and nbFiltered
	// return 1 if u was matched with v in the globalMatching, 0 otherwise



int last_pos2(int u, int v, int prof, Tdomain* D);
	// remove v from the domain of u at the depth prof in the search tree and update the globalMatching
	// return 1 if u was matched with v in the globalMatching, 0 otherwise




void matchVertices(int prof, int u, int v, Tdomain* D, Tgraph* Gp, Tgraph* Gt, int* nbMatched);
	// filter domains of other vertices at the depth prof in the search tree consequently of the matching of u with v and update the globalMatching




unsigned char AC3(Tdomain* D, Tgraph* Gp, int prof);
	// perform arc consistency and return 0 if an inconsistency is detected at the depth prof in the search tree and 1 otherwise





int filter(int prof, Tdomain* D, Tgraph* Gp, Tgraph* Gt, int maxSize);
	// returns the number of variables that can be assigned w.r.t SoftAlldiff constraint at the depth prof in the search tree



int filter_GAC(int prof, Tdomain* D, Tgraph* Gp, Tgraph* Gt, int maxSize);
	// returns the number of variables that can be assigned w.r.t SoftAlldiff constraint at the depth prof in the search tree


#endif
